unit Tools;
interface

uses Windows;

Function ExtUpperCase(const S : String) : String;
Function GetSpecialFolder(hWindow: HWND; Folder: Integer): String;

implementation

uses SysUtils, ActiveX, ShlObj;

Function ExtUpperCase(const S : String) : String;
const LanguageSpecialLowerCase='庸賿';
      LanguageSpecialUpperCase='åŪȲӡ';
Var I,J : Integer;
begin
  result:=Trim(S);
  For I:=1 to length(result) do begin
    If (result[I]>='a') and (result[I]<='z') then begin
      result[I]:=chr(ord(result[I])-(ord('a')-ord('A')));
      continue;
    end;
    J:=Pos(result[I],LanguageSpecialLowerCase);
    If J>0 then result[I]:=LanguageSpecialUpperCase[J];
  end;
end;

Function GetSpecialFolder(hWindow: HWND; Folder: Integer): String;
var pMalloc: IMalloc;
    pidl: PItemIDList;
    Path: PChar;
begin
  result:='';
  if SHGetMalloc(pMalloc) <> S_OK then exit;

  SHGetSpecialFolderLocation(hWindow, Folder, pidl);
  GetMem(Path, MAX_PATH);
  SHGetPathFromIDList(pidl, Path);
  Result := Path;
  FreeMem(Path);

  pMalloc.Free(pidl);
end;

end.
